Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkCell Class Reference

`#include <vtkCell.h>`

Inheritance diagram for vtkCell:

[legend]
Collaboration diagram for vtkCell:

[legend]
List of all members.

## Detailed Description

abstract class to specify cell behavior

Date:
  2002/12/26 18:24:21

Revision:
  1.79

vtkCell is an abstract class that specifies the interfaces for data cells. Data cells are simple topological elements like points, lines, polygons, and tetrahedra of which visualization datasets are composed. In some cases visualization datasets may explicitly represent cells (e.g., vtkPolyData, vtkUnstructuredGrid), and in some cases, the datasets are implicitly composed of cells (e.g., vtkStructuredPoints).

Warning:
  The define VTK_CELL_SIZE is a parameter used to construct cells and provide a general guideline for controlling object execution. This parameter is not a hard boundary: you can create cells with more points.

See also:
  vtkHexahedron vtkLine vtkPixel vtkPolyLine vtkPolyVertex vtkPolygon vtkQuad vtkTetra vtkTriangle vtkTriangleStrip vtkVertex vtkVoxel vtkWedge vtkPyramid

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (66%)
  - Martin, Ken (6%)
  - Geveci, Berk (6%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkCell.cxx)`
  - .`h` (`/Common/vtkCell.h)`

Tests:
  vtkCell (Tests)

Definition at line 73 of file vtkCell.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Initialize (int npts, vtkIdType *pts, vtkPoints *p)
virtual vtkCell * | MakeObject ()
virtual void | ShallowCopy (vtkCell *c)
virtual void | DeepCopy (vtkCell *c)
virtual int | GetCellType ()=0
virtual int | GetCellDimension ()=0
virtual int | IsLinear ()
virtual int | IsExplicitCell ()
vtkPoints * | GetPoints ()
int | GetNumberOfPoints ()
virtual int | GetNumberOfEdges ()=0
virtual int | GetNumberOfFaces ()=0
vtkIdList * | GetPointIds ()
vtkIdType | GetPointId (int ptId)
virtual vtkCell * | GetEdge (int edgeId)=0
virtual vtkCell * | GetFace (int faceId)=0
virtual int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)=0
virtual int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)=0
void | GetBounds (float bounds[6])
float * | GetBounds ()
float | GetLength2 ()
virtual int | GetParametricCenter (float pcoords[3])
virtual int | RequiresInitialization ()
virtual void | Initialize ()
virtual int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)=0
virtual void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)=0
virtual void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)=0
virtual void | Clip (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *connectivity, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut)=0
virtual int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)=0
virtual void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)=0
## Static Public Methods
int | IsTypeOf (const char *type)
vtkCell * | SafeDownCast (vtkObject *o)
char | HitBBox (float bounds[6], float origin[3], float dir[3], float coord[3], float &t)
## Public Attributes
vtkPoints * | Points
vtkIdList * | PointIds
## Protected Methods
| vtkCell ()
| ~vtkCell ()
## Protected Attributes
float | Bounds [6]

## Member Typedef Documentation

typedef vtkObject vtkCell::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkExplicitCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkNonLinearCell, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge. Definition at line 76 of file vtkCell.h.

## Constructor & Destructor Documentation

vtkCell::vtkCell | ( |  | ) | `[protected]`

vtkCell::~vtkCell | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkCell::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkExplicitCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkNonLinearCell, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

int vtkCell::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkExplicitCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkNonLinearCell, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkExplicitCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkNonLinearCell, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

vtkCell* vtkCell::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkExplicitCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkNonLinearCell, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

void vtkCell::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkCell3D, vtkExplicitCell, and vtkNonLinearCell.

void vtkCell::Initialize | ( | int | npts,
|  | vtkIdType * | pts,
|  | vtkPoints * | p
| ) |

| Initialize cell from outside with point ids and point coordinates specified.

virtual vtkCell* vtkCell::MakeObject | ( |  | ) | `[virtual]`

| For legacy compatibility. Do not use.

virtual void vtkCell::ShallowCopy | ( | vtkCell * | c | ) | `[virtual]`

| Copy this cell by reference counting the internal data structures. This is safe if you want a "read-only" copy. If you modify the cell you might wish to use DeepCopy(). Reimplemented in vtkGenericCell.

virtual void vtkCell::DeepCopy | ( | vtkCell * | c | ) | `[virtual]`

| Copy this cell by completely copying internal data structures. This is slower but safer than ShallowCopy(). Reimplemented in vtkGenericCell.

virtual int vtkCell::GetCellType | ( |  | ) | `[pure virtual]`

| Return the type of cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::GetCellDimension | ( |  | ) | `[pure virtual]`

| Return the topological dimensional of the cell (0,1,2, or 3). Implemented in vtkCell3D, vtkEmptyCell, vtkGenericCell, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::IsLinear | ( |  | ) | `[inline, virtual]`

| Non-linear cells require special treatment beyond the usual cell type and connectivity list information. Most cells in VTK are implicit cells. Reimplemented in vtkGenericCell, and vtkNonLinearCell. Definition at line 106 of file vtkCell.h.

virtual int vtkCell::RequiresInitialization | ( |  | ) | `[inline, virtual]`

| Some cells require initialization prior to access. For example, they may have to triangulate themselves or set up internal data structures. Reimplemented in vtkConvexPointSet, and vtkGenericCell. Definition at line 112 of file vtkCell.h.

virtual void vtkCell::Initialize | ( |  | ) | `[inline, virtual]`

| Some cells require initialization prior to access. For example, they may have to triangulate themselves or set up internal data structures. Reimplemented in vtkConvexPointSet, and vtkGenericCell. Definition at line 113 of file vtkCell.h.

virtual int vtkCell::IsExplicitCell | ( |  | ) | `[inline, virtual]`

| Explicit cells require additional representational information beyond the usual cell type and connectivity list information. Most cells in VTK are implicit cells. Reimplemented in vtkExplicitCell. Definition at line 119 of file vtkCell.h.

vtkPoints* vtkCell::GetPoints | ( |  | ) | `[inline]`

| Get the point coordinates for the cell. Definition at line 122 of file vtkCell.h.

int vtkCell::GetNumberOfPoints | ( |  | ) | `[inline]`

| Return the number of points in the cell. Definition at line 125 of file vtkCell.h. Referenced by vtkTriangleStrip::GetNumberOfEdges(), vtkPolygon::GetNumberOfEdges(), and vtkCellArray::InsertNextCell().

virtual int vtkCell::GetNumberOfEdges | ( |  | ) | `[pure virtual]`

| Return the number of edges in the cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::GetNumberOfFaces | ( |  | ) | `[pure virtual]`

| Return the number of faces in the cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

vtkIdList* vtkCell::GetPointIds | ( |  | ) | `[inline]`

| Return the list of point ids defining the cell. Definition at line 134 of file vtkCell.h.

vtkIdType vtkCell::GetPointId | ( | int | ptId | ) | `[inline]`

| For cell point i, return the actual point id. Definition at line 137 of file vtkCell.h. References vtkIdType.

virtual vtkCell* vtkCell::GetEdge | ( | int | edgeId | ) | `[pure virtual]`

| Return the edge cell from the edgeId of the cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual vtkCell* vtkCell::GetFace | ( | int | faceId | ) | `[pure virtual]`

| Return the face cell from the faceId of the cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[pure virtual]`

| Given parametric coordinates of a point, return the closest cell boundary, and whether the point is inside or outside of the cell. The cell boundary is defined by a list of points (pts) that specify a face (3D cell), edge (2D cell), or vertex (1D cell). If the return value of the method is != 0, then the point is inside the cell. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[pure virtual]`

| Given a point x[3] return inside(=1) or outside(=0) cell; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell. (The number of weights is equal to the number of points defining the cell). Note: on rare occasions a -1 is returned from the method. This means that numerical error has occurred and all data returned from this method should be ignored. Also, inside/outside is determine parametrically. That is, a point is inside if it satisfies parametric limits. This can cause problems for cells of topological dimension 2 or less, since a point in 3D can project onto the cell within parametric limits but be "far" from the cell. Thus the value dist2 may be checked to determine true in/out. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual void vtkCell::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[pure virtual]`

| Determine global coordinate (x[3]) from subId and parametric coordinates. Also returns interpolation weights. (The number of weights is equal to the number of points in the cell.) Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual void vtkCell::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[pure virtual]`

| Generate contouring primitives. The scalar list cellScalars are scalar values at each cell point. The point locator is essentially a points list that merges points as they are inserted (i.e., prevents duplicates). Contouring primitives can be vertices, lines, or polygons. It is possible to interpolate point data along the edge by providing input and output point data - if outPd is NULL, then no interpolation is performed. Also, if the output cell data is non-NULL, the cell data from the contoured cell is passed to the generated contouring primitives. (Note: the CopyAllocate() method must be invoked on both the output cell and point data. The cellId refers to the cell from which the cell data is copied.) Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual void vtkCell::Clip | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | connectivity,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd,
|  | int | insideOut
| ) | `[pure virtual]`

| Cut (or clip) the cell based on the input cellScalars and the specified value. The output of the clip operation will be one or more cells of the same topological dimension as the original cell. The flag insideOut controls what part of the cell is considered inside - normally cell points whose scalar value is greater than "value" are considered inside. If insideOut is on, this is reversed. Also, if the output cell data is non-NULL, the cell data from the clipped cell is passed to the generated contouring primitives. (Note: the CopyAllocate() method must be invoked on both the output cell and point data. The cellId refers to the cell from which the cell data is copied.) Implemented in vtkCell3D, vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, and vtkVertex.

virtual int vtkCell::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[pure virtual]`

| Intersect with a ray. Return parametric coordinates (both line and cell) and global intersection coordinates, given ray definition and tolerance. The method returns non-zero value if intersection occurs. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual int vtkCell::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[pure virtual]`

| Generate simplices of proper dimension. If cell is 3D, tetrahedron are generated; if 2D triangles; if 1D lines; if 0D points. The form of the output is a sequence of points, each n+1 points (where n is topological cell dimension) defining a simplex. The index is a parameter that controls which triangulation to use (if more than one is possible). If numerical degeneracy encountered, 0 is returned, otherwise 1 is returned. Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

virtual void vtkCell::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[pure virtual]`

| Compute derivatives given cell subId and parametric coordinates. The values array is a series of data value(s) at the cell points. There is a one-to-one correspondence between cell point and data value(s). Dim is the number of data values per cell point. Derivs are derivatives in the x-y-z coordinate directions for each data value. Thus, if computing derivatives for a scalar function in a hexahedron, dim=1, 8 values are supplied, and 3 deriv values are returned (i.e., derivatives in x-y-z directions). On the other hand, if computing derivatives of velocity (vx,vy,vz) dim=3, 24 values are supplied ((vx,vy,vz)1, (vx,vy,vz)2, ....()8), and 9 deriv values are returned ((d(vx)/dx),(d(vx)/dy),(d(vx)/dz), (d(vy)/dx),(d(vy)/dy), (d(vy)/dz), (d(vz)/dx),(d(vz)/dy),(d(vz)/dz)). Implemented in vtkConvexPointSet, vtkEmptyCell, vtkGenericCell, vtkHexahedron, vtkLine, vtkPixel, vtkPolygon, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuad, vtkQuadraticEdge, vtkQuadraticHexahedron, vtkQuadraticQuad, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, vtkVertex, vtkVoxel, and vtkWedge.

void vtkCell::GetBounds | ( | float | bounds[6] | ) |

| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). Copy result into user provided array.

float* vtkCell::GetBounds | ( |  | ) |

| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). Return pointer to array of six float values.

float vtkCell::GetLength2 | ( |  | ) |

| Compute Length squared of cell (i.e., bounding box diagonal squared).

virtual int vtkCell::GetParametricCenter | ( | float | pcoords[3] | ) | `[virtual]`

| Return center of the cell in parametric coordinates. Note that the parametric center is not always located at (0.5,0.5,0.5). The return value is the subId that the center is in (if a composite cell). If you want the center in x-y-z space, invoke the EvaluateLocation() method. Reimplemented in vtkConvexPointSet, vtkGenericCell, vtkPolyLine, vtkPolyVertex, vtkPyramid, vtkQuadraticTetra, vtkQuadraticTriangle, vtkTetra, vtkTriangle, vtkTriangleStrip, and vtkWedge.

char vtkCell::HitBBox | ( | float | bounds[6],
|  | float | origin[3],
|  | float | dir[3],
|  | float | coord[3],
|  | float & | t
| ) | `[static]`

| Bounding box intersection modified from Graphics Gems Vol I. The method returns a non-zero value if the bounding box is hit. Origin[3] starts the ray, dir[3] is the vector components of the ray in the x-y-z directions, coord[3] is the location of hit, and t is the parametric coordinate along line. (Notes: the intersection ray dir[3] is NOT normalized. Valid intersections will only occur between 0<=t<=1.)

## Member Data Documentation

vtkPoints* vtkCell::Points

| Definition at line 290 of file vtkCell.h.

vtkIdList* vtkCell::PointIds

| Definition at line 291 of file vtkCell.h. Referenced by vtkCellArray::InsertNextCell().

float vtkCell::Bounds[6]`[protected]`

| Definition at line 297 of file vtkCell.h.

The documentation for this class was generated from the following file:

- Common/vtkCell.h